    
    
    const pzem_232_readV    = new Uint8Array([0xB0, 0xC0, 0xA8, 0x01, 0x01, 0x00, 0x1A]);
    const pzem_232_readI    = new Uint8Array([0xB1,0xC0,0xA8,0x01,0x01,0x00,0x1B]);
    const pzem_232_readP    = new Uint8Array([0xB2,0xC0,0xA8,0x01,0x01,0x00,0x1C]);
    const pzem_232_readW    = new Uint8Array([0xB3,0xC0,0xA8,0x01,0x01,0x00,0x1D]);
    const pzem_232_setaddr  = new Uint8Array([0xB4,0xC0,0xA8,0x01,0x01,0x00,0x1E]);

/*        
serialPorts = { 
    "1": {
        serialObj:      null, 
        isOpened:       false, 
        portid:         portobj.id,        
        type:           portobj.port_type,
        name:           portobj.port_name, 
        isBusy:         false, 
        baudrate:       portobj.port_baudrate, 
        databits:       portobj.port_databits, 
        flowcontrol:    portobj.port_flowcontrol, 
        parity:         portobj.port_parity, 
        stopbits:       portobj.port_stopbits,
        reader:         null,
        writer:         null,
        writeQueue:     [],
        readBuffer:     []
    }
}
*/
    var serialPorts = {};
    
/*
PZEMdevices ={
    "1" : {
        device:         {   // copy of DB record
                            pzem_name:      pzname, 
                            pzem_descr:     pzdescr, 
                            pzem_port:      pzport, 
                            logDB:          logDB,
                            delDB:          delDB,
                            devtype:        devtype,
                            pzem_settings:  {
                                                readVoltage:        false, 
                                                readCurrent:        false, 
                                                readPower:          false, 
                                                readEnergy:         false, 
                                                readFrequency:      false, 
                                                readPowerfactor:    false,
                                                pollDelay:          5,
                                                nrjAdjust:          0,
                                                slaveAddr:          248
                                            
                                            }  
                        }
        port_type:      cur_port.type,      // type form serialPorts
        counter:        0,                  // divider for main counter, actually.
        pkt_cntr:       0,                  // measurements received without error
        err_cntr:       0,                  // transmission errors
        active:         false               // enable/disable polling
    }

}
*/
    var PZEMdevices = {};
    
  
    
    
    
    var devTypesRS485 = {
        "pzem-014/016":     {
            getMeasReq:     function( slave_addr ){
                                return [slave_addr, 0x04, 0x00, 0x00, 0x00, 0x09 ];
                            },
            measOKlen:      23,     // length of normal reply with measurements data
            measOKcode:     0x04,   // second byte of normal reply with measurements data
            measERRlen:     5,      // length of error message from PZEM when measurements were requested
            measERRcode:    0x84,    // second byte of the error message
            getV:           function( buf ){
                                return (((buf[3] << 8) | buf[4] ) & 0xFFFF) / 10 ;
                            },
            getI:           function( buf ){
                                return ( ( (buf[7] << 24) | (buf[8] << 16) | (buf[5] << 8) |  buf[6] ) & 0xFFFFFFFF ) /1000;
                            },            
            getP:           function( buf ){
                                return (( (buf[11] << 24) | (buf[12] << 16) | (buf[9] << 8) |  buf[10] ) & 0xFFFFFFFF) / 10;
                            },
            getE:           function( buf ){
                                return ( (buf[15] << 24) | (buf[16] << 16) | (buf[13] << 8) |  buf[14] ) & 0xFFFFFFFF;
                            },
            getF:           function( buf ){
                                return (((buf[17] << 8) | buf[18] ) & 0xFFFF) / 10 ;
                            },
            getPF:          function( buf ){
                                return (((buf[19] << 8) | buf[20] ) & 0xFFFF) / 100 ;
                            },
            getChAddrReq:   function( slave_addr, newaddr ){
                                return [slave_addr, 0x06, 0x00, 0x02, 0x00, (newaddr & 0xFF) ];
                            },
            getNrjResReq:   function( slave_addr ){
                                return [slave_addr, 0x42 ];
                            },
            srvOKlen:       8,
            srvOKcode:      0x06,
            srvERRlen:      5,
            srvERRcode:     0x86,
            nrjResOKlen:    4,
            nrjResOKcode:   0x42,
            nrjResERRlen:   5,
            nrgResERRcode:  0xC2
                            
        },
    
        "pzem-003/017":     {
            getMeasReq:     function( slave_addr ){
                                return [slave_addr, 0x04, 0x00, 0x00, 0x00, 0x06 ];
                            },
            measOKlen:      17,     
            measOKcode:     0x04,   
            measERRlen:     5,      
            measERRcode:    0x84,
            getV:           function( buf ){
                                return (((buf[3] << 8) | buf[4] ) & 0xFFFF) / 100 ;
                            },
            getI:           function( buf ){
                                return ( ((buf[5] << 8) |  buf[6] ) & 0xFFFFFFFF ) /100;
                            },            
            getP:           function( buf ){
                                return (( (buf[9] << 24) | (buf[10] << 16) | (buf[7] << 8) |  buf[8] ) & 0xFFFFFFFF) / 10;
                            },
            getE:           function( buf ){
                                return ( (buf[13] << 24) | (buf[14] << 16) | (buf[11] << 8) |  buf[12] ) & 0xFFFFFFFF;
                            },
            getF:           function( buf ){
                                return null;
                            },
            getPF:          function( buf ){
                                return null;
                            },
            getChAddrReq:   function( slave_addr, newaddr ){
                                return [slave_addr, 0x06, 0x00, 0x02, 0x00, (newaddr & 0xFF) ];
                            },
            getNrjResReq:   function( slave_addr ){
                                return [slave_addr, 0x42 ];
                            },
            srvOKlen:       8,
            srvOKcode:      0x06,
            srvERRlen:      5,
            srvERRcode:     0x86,
            nrjResOKlen:    4,
            nrjResOKcode:   0x42,
            nrjResERRlen:   5,
            nrgResERRcode:  0xC2
        },
        
        "pzem-004t v3.0":     null,

    };
    
    devTypesRS485['pzem-004t v3.0'] = devTypesRS485['pzem-014/016'];
   
    RS485ErrCode = ["empty", "Illegal function", "Illegal address", "Illegal data", "Slave error"];
    
    
    //=============================
    var m_cntr = 0;
    
    function process_queue(){
    
        m_cntr++;
        if( (curPage == 0) && (m_cntr % 10 == 0) ){
            $.each( Object.keys(serialPorts), function( index, portid ) {
                placeQueueData(portid);
            });
        }

     
        for (const devid of Object.keys( PZEMdevices ) ){ 
            
            if( PZEMdevices[devid]['active'] == false ) continue;
            
            var port_id = PZEMdevices[devid]['device']['pzem_port'];
            var cur_port = serialPorts[port_id];
            
            var cntr  = PZEMdevices[devid]['counter'];
            var delay = PZEMdevices[devid]['device']['pzem_settings']['pollDelay'];  // it is a divider for counter actually
            
            if( cntr == 0 || (cntr % delay ) == 0 ){
            
                if( PZEMdevices[devid]['port_type'] == "RS232" ){
                    if( cur_port.isBusy ){
                        console.error(" Port Id " + port_id + " is busy for device Id " + devid);
                        PZEMdevices[devid]['err_cntr']++
                    }else{
                        get_RS232_packet( devid )
                            .catch( err => { 
                                console.error(err); 
                                cur_port.isBusy = false; 
                                cur_port.writer.releaseLock(); 
                            });
                    }
                    
                }else if ( PZEMdevices[devid]['port_type'] == "RS485" ){
                    var slave_address = PZEMdevices[devid]['device']['pzem_settings']['slaveAddr']
                    // the busy state for this port is normal because it may has multiple slaves
                    // we just put polling request to the queue and wait when the port will be able to process it
                    // there is a array in the port descriptor: "writeQueue" where we put our request to
                    // and actual writer will be unshifting data from this queue
                    // we must indicate queue length somewhere on the interface to see if it is growing
                    //cur_port.writeQueue.push([address, 0xA1]); // [slave address, operation, additional data] 
                    cur_port.writeQueue.push([devid, slave_address, 0xA1]); // [slave address, operation, additional data] 
                }else{
                    console.log("unknown port type: " + PZEMdevices[devid]['port_type'] );
                }
            }
            

            
            if( PZEMdevices[devid]['device']['logDB']  && PZEMdevices[devid]['device']['delDB'] > 0 && (cntr % (delay*10) ) == 0 ){
                //console.log("clearing db");
                remove_old_db_records(devid);
            }
            
            //readRS232( active_device_id, db );
            
            PZEMdevices[devid]['counter'] += 50;

        }
        
        // each timer tick we're trying to process the write queue for RS485 port
        for (const port_id of Object.keys( serialPorts ) ){
            cur_port = serialPorts[port_id];
            if( cur_port.type == "RS485" && cur_port.isOpened == true && cur_port.isBusy == false ){
                process_RS485_queue(port_id)    
                        .catch( err=>{ 
                            console.error(err); 
                            cur_port.isBusy = false; 
                            cur_port.writer.releaseLock(); 
                        });
            }
        
        }
                     

        

    }
    
    
    ///////////////////////////////////////////////////
    async function process_RS485_queue(port_id){

        var cur_port = serialPorts[port_id];
        
        cur_port.isBusy = true;
        
        if( cur_port === undefined || cur_port == null || cur_port.isOpened == false){
            throw new Error('error while trying to request data from device Id ' + device_id + ". Serial port not found.");
        }
        
        if( cur_port.writeQueue.length == 0 ) {
            cur_port.isBusy = false; 
            return;
        }
        var task = cur_port.writeQueue.shift();
        
        var device_id   = task[0];
        var sl_addr     = task[1];
        var cmd         = task[2];
        
        var devtype = PZEMdevices[device_id]['device']['devtype'];
        
        if( devTypesRS485[devtype] === undefined ){
            throw new Error('unknown device type for RS485 port: ' + devtype);
        }
        
        devtype = devTypesRS485[devtype];
        
        //var ts          = new Date();
        
        const writer = cur_port.serialObj.writable.getWriter();
        cur_port.writer = writer;
        
        
        if( cmd == 0xA1 ){ // request measurements
            
            var req = devtype.getMeasReq( sl_addr );
            //var req = [ task[0], 0x04, 0x00, 0x00, 0x00, 0x09];
            var crc = MODBUScrc16(req);
            
            var crcL = crc & 0xFF;
            var crcH = (crc >> 8) & 0xFF;
            
            req.push(crcL);
            req.push(crcH);
      
            await writer.write( new Uint8Array(req) );
            //cur_port['readBuffer'].length = 0;
            var resp = await get_rs485_reply( device_id, PZEMdevices[device_id]['device'] )
                .catch(err =>{ 
                    console.error(err)
                    PZEMdevices[device_id]['err_cntr']++;
                    placeCellData(device_id, 'XX', 0); // update error counter
                    throw new Error('RS486 packet lost for device Id: ' + device_id + '  '+ err);
                });
            

            resp.ts = getLocalMillisec();
            PZEMdevices[device_id]['pkt_cntr']++;
            var pzs = PZEMdevices[device_id]['device']['pzem_settings'];
            
            if( pzs.readVoltage )       placeCellData(device_id, 'V', resp.v);
            if( pzs.readCurrent )       placeCellData(device_id, 'I', resp.i);
            if( pzs.readPower )         placeCellData(device_id, 'P', resp.p);
            if( pzs.readEnergy )        placeCellData(device_id, 'E', resp.e);
            if( pzs.readFrequency )     placeCellData(device_id, 'F', resp.f);
            if( pzs.readPowerfactor )   placeCellData(device_id, 'PF', resp.pf);
            
            if( PZEMdevices[device_id]['device']['logDB'] ){
                var record = {
                    ts:         resp.ts,
                    devid:      parseInt(device_id),
                    v:          pzs.readVoltage     ? resp.v : null,
                    i:          pzs.readCurrent     ? resp.i : null,
                    p:          pzs.readPower       ? resp.p : null,
                    e:          pzs.readEnergy      ? resp.e : null,
                    f:          pzs.readFrequency   ? resp.f : null,
                    pf:         pzs.readPowerfactor ? resp.pf: null
                };
            
                db.records.put(record)
                    .then( id => {
                    //
                    },err => {
                        console.log("DB record failed " + err);
                    });
            }
                
                delete resp;

        }else if( cmd == 0xA2 ){ // change slave addr
            var req = devtype.getChAddrReq(sl_addr, task[3]);
            var crc = MODBUScrc16(req);
            
            var crcL = crc & 0xFF;
            var crcH = (crc >> 8) & 0xFF;
            
            req.push(crcL);
            req.push(crcH);
            
 
            await writer.write( new Uint8Array(req) );
            var resp = await get_rs485_reply( device_id, PZEMdevices[device_id]['device'] )
                .catch(err =>{ 
                    console.error(err)
                    $("#configure_RS485_resp_msg").html("<div style='color:#a93226'>Address changing failed: " + err + "div>");
                    throw new Error('RS486 change slave address failed for device Id: ' + device_id + '  '+ err);
                });
                
            $("#configure_RS485_resp_msg").html("<div style='color:#117a65'>Address changed OK</div>");    
            
        }else if( cmd == 0xA3 ){ // reset energy counter
            var req = devtype.getNrjResReq(sl_addr);
            var crc = MODBUScrc16(req);
            
            var crcL = crc & 0xFF;
            var crcH = (crc >> 8) & 0xFF;
            
            req.push(crcL);
            req.push(crcH);
            
 
            await writer.write( new Uint8Array(req) );
            var resp = await get_rs485_reply( device_id, PZEMdevices[device_id]['device'] )
                .catch(err =>{ 
                    console.error(err)
                    $("#configure_RS485_resp_msg").html("<div style='color:#a93226'>energy reset failed: " + err + "div>");
                    throw new Error('RS486 energy reset failed for device Id: ' + device_id + '  '+ err);
                });
                
            $("#configure_RS485_resp_msg").html("<div style='color:#117a65'>Energy reset OK</div>");
        }
        
        
        writer.releaseLock();
        //console.log("processing time: " + (new Date() - ts));
        cur_port.isBusy = false;
        
        return true;
    } 
    
    
    
    

///////////////////////////////////////////////////

    
    async function get_RS232_packet( device_id ){
        
        //var ts          = new Date();
        var pkt_is_lost = false;
        var last_pkt    = false;
        var port_id     = PZEMdevices[device_id]['device']['pzem_port'];
        var pzs         = PZEMdevices[device_id]['device']['pzem_settings'];
        
        var cur_port = serialPorts[port_id]; 
        if( cur_port === undefined || cur_port == null || cur_port.isOpened == false){
            console.log('error while trying to request data from device Id '+device_id+". Serial port not found." );
            //delete pollingQueue[ device_id ];
            //if( curPage == 1 ) $("#pzemtable").trigger("reloadGrid");
            return;
        }
 
        cur_port.isBusy = true;
        
        var dbrecord = {
                            ts:         null,
                            devid:      null,
                            v:          null,
                            i:          null,
                            p:          null,
                            e:          null,
                            f:          null,
                            pf:         null
                        };
        
        
        const writer = cur_port.serialObj.writable.getWriter();
        cur_port.writer = writer;
        
        if( pzs.readVoltage ){
           
            await writer.write( pzem_232_readV );
            
            await get_rs232_reply( device_id )
                .then( v =>{
                    placeCellData(device_id, 'V', v);
                    dbrecord.v = v;
                }, err =>{
                    console.error('error: ', err);
                    pkt_is_lost = true;
                });
            
            if( !pzs.readCurrent && !pzs.readPower && !pzs.readEnergy ) last_pkt = true;
        }
        
        if( !pkt_is_lost && pzs.readCurrent ){
          
            await writer.write( pzem_232_readI );

            await get_rs232_reply( device_id )
                .then( i =>{
                    placeCellData(device_id, 'I', i);
                    dbrecord.i = i;
                }, err =>{
                    console.error('error: ', err);
                    pkt_is_lost = true;
                });

            if( !pzs.readPower && !pzs.readEnergy ) last_pkt = true;
        }
        
        if( !pkt_is_lost && pzs.readPower ){
           
            await writer.write( pzem_232_readP );

            await get_rs232_reply( device_id )
                .then( p =>{
                    placeCellData(device_id, 'P', p);
                    dbrecord.p = p;
                }, err =>{
                    console.error('error: ', err);
                    pkt_is_lost = true;
                });
    
            
            if( !pzs.readEnergy ) last_pkt = true;

        }
        
        if( !pkt_is_lost && pzs.readEnergy ){
         
            await writer.write( pzem_232_readW );

            await get_rs232_reply( device_id )
                .then( e =>{
                    placeCellData(device_id, 'E', e);
                    dbrecord.e = e;
                }, err =>{
                    console.error('error: ', err);
                    pkt_is_lost = true;
                });
   
            
            last_pkt = true;
        }
        
        
        
        if( pkt_is_lost ) PZEMdevices[device_id]['err_cntr']++;
        
        if( !pkt_is_lost && last_pkt && PZEMdevices[device_id]['device']['logDB'] ){
            PZEMdevices[device_id]['pkt_cntr']++;
            
            dbrecord.ts = getLocalMillisec();
            dbrecord.devid = parseInt(device_id);
            
            db.records.put(dbrecord)
                .then( id => {
                    //
                },err => {
                    console.log("DB record failed " + err);
                });
        }
        
        writer.releaseLock();
        //console.log("processing time: " + (new Date() - ts));
        cur_port.isBusy = false;
        
    }
////////////////////////////////////
    async function get_rs485_reply( device_id, device ){
    
        var port_id  = device.pzem_port;
        //var arr      = serialPortBuffer[port_id];
        var arr      = serialPorts[port_id]['readBuffer'];
        var pzs      = device.pzem_settings;
        
        var devtype = devTypesRS485[ device.devtype ];
        
        var i = 100; // just about 500ms max read timeout because RS485 devices are damn fast! :D
        
        while( i > 0){
            if( 
                (arr.length == devtype.measOKlen    && arr[1] == devtype.measOKcode)        || 
                (arr.length == devtype.measERRlen   && arr[1] == devtype.measERRcode)       ||
                (arr.length == devtype.srvOKlen     && arr[1] == devtype.srvOKcode)         ||
                (arr.length == devtype.srvERRlen    && arr[1] == devtype.srvERRcode)        ||
                (arr.length == devtype.nrjResOKlen  && arr[1] == devtype.nrjResOKcode)      ||
                (arr.length == devtype.nrjResERRlen && arr[1] == devtype.nrjResERRcode)
            ){
                break;
            } else{
                await delayms( 10 );
            }
            i--;
        }
        
        if( i <= 0 ){
            console.log(serialPorts[port_id]['readBuffer']);
            arr.length = 0;
            throw new Error('port read timeout for device Id ' + device_id);
        }
        
        var msg_checksum    = ((arr[ arr.length-1 ] << 8) & 0xFF00) | (arr[ arr.length-2 ] & 0x00FF);
        var calc_checksum   = MODBUScrc16( arr.slice(0, -2 ));
        if( msg_checksum != calc_checksum ){
            arr.length = 0;
            throw new Error('Wrong checksum for device Id ' + device_id + '  ' + msg_checksum + ' != ' + calc_checksum);
        }
        
        if( arr.length == devtype.measERRlen || arr.length == devtype.srvERRlen || arr.length == devtype.nrjResERRlen ){
            var c = arr[2];
            arr.length = 0;
            throw new Error("Slave error: " + pzs['slaveAddr'] + '  ' + RS485ErrCode[c]);
        }
        
        if( arr[0] != pzs['slaveAddr'] ){
            var c = arr[0];
            arr.length = 0;
            throw new Error('Wrong slave address in reply for device Id ' + device_id + ' : ' + c);
        }

        if( arr.length == devtype.measOKlen ){ // we got measurements
            var resp_obj = {
                v:  devtype.getV( arr ), 
                i:  devtype.getI( arr ),
                p:  devtype.getP( arr ),
                e:  devtype.getE( arr ),
                f:  devtype.getF( arr ),
                pf: devtype.getPF( arr )
            };

            arr.length = 0;
        
            return resp_obj;
        }

        
        if( arr.length == devtype.srvOKlen || arr.length == devtype.nrjResOKlen){  // we got service message
            console.log("RS485 service message:");
            console.log(arr);
        }
        
   
        //console.log(serialPortBuffer[port_id]);
        arr.length = 0;
        
        return true;
        
    };

////////////////////////////////////

    async function get_rs232_reply( device_id){
        
        var port_id  = PZEMdevices[device_id]['device']['pzem_port'];
        var arr      = serialPorts[port_id]['readBuffer'];
        var pzs      = PZEMdevices[device_id]['device']['pzem_settings'];
        
        var i = 100; // about 2 seconds max read timeout
        
        while( i > 0){
            if( arr.length == 7 ){
                break;
            } else{
                await delayms( 20 );
            }

            i--;
        }
        
        if( i <= 0 ){
            console.log(serialPorts[port_id]['readBuffer']);
            arr.length = 0;
            throw new Error('port read timeout for device Id ' + device_id);
        } 
        
        
        
        if( arr[0] < 0xa0 && arr[0] > 0xa5 ){
            arr.length = 0;
            throw new Error('wrong header for device Id ' + device_id);
        }
        
        var checksum = 0;
        for( var i=0; i<=5; i++){ 
            checksum += arr[i] & 0xff;
        }
        checksum = checksum & 0xff;
        
        if(arr[6] != checksum){
            var c = arr[6];
            arr.length = 0;
            throw new Error('wrong checksum ' + c + ' != ' + checksum + ' for device Id ' + device_id);
        }
        
        
        if(arr[0] == 0xa0 ){ // Voltage
            var v = ( (arr[1] & 0xFF) << 8) | (arr[2] & 0xFF);
            v = parseFloat(v + '.' + arr[3]);
            arr.length = 0;
            return v;
        }else if( arr[0] == 0xa1 ){ // Current
            var i = parseFloat(arr[2] + '.' + arr[3]);
            arr.length = 0;
            return i;
        }else if( arr[0] == 0xa2 ){ // Power
            var p = ( (arr[1] & 0xFF) << 8) | (arr[2] & 0xFF);
            arr.length = 0;
            return p;
        }else if( arr[0] == 0xa3 ){ // Energy
            var e = ( (arr[1] & 0xFF) << 16) | (arr[2] & 0xFF) << 8 | (arr[3] & 0xFF);
            if( pzs.nrjAdjust != 0) e -= pzs.nrjAdjust;
            arr.length = 0;            
            return e;
         }else{
            var c = arr[0];
            arr.length = 0;
            throw new Error('unimplemented header [' + c + '] for device Id ' + device_id);
        }

        return true;
    }
    
////////////////////////////////////    

    async function listen_serial_port( port_id ){
    
        var port = serialPorts[port_id]['serialObj'];
     
        while (port.readable && serialPorts[port_id].keepReading) {
            const reader = await port.readable.getReader();
            serialPorts[port_id]['reader'] = reader;
            try {
                while (true) {
                    const { value, done } = await reader.read();
                    if (done) {
                        break;
                    }
                    // copy data from serial port stream to the device's simple array
                    //console.log(value);
                    value.forEach(function(item, index) {
                        //serialPortBuffer[port_id].push( item );
                        serialPorts[port_id]['readBuffer'].push( item );
                    });
                }
            } catch (error) {
                console.error( error );
            } finally {
                reader.releaseLock();
            }
        }
    }