//=============================

    function init_data_table(){
        
        dateTimePick = function(elem){
            $(elem).datetimepicker({ 
                dateFormat: 'yy-mm-dd', 
                timeFormat: 'HH:mm:ss',
                showHour: true,
                showMinute: true,
                showSecond: true,
                showMillisec: false,
                showMicrosec: false,
                showTimezone: false
            });
        };
        
        
        
        $("#datatable").jqGrid({ 
            datatype: function(postdata) {
                
                if(curPage != 2) return;
                
                (async function() {
                    var jk = new Date(); 
                    var filtered = "";
                    if( postdata['_search'] == true ) filtered = "<span style='background-color:#a93226'>[filtered] </span>";
                    
                    $("#datatable").jqGrid("setCaption", "<span>Data records &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>" + filtered + "&nbsp;&nbsp;&nbsp;<span>[ processing... ]</span>");
                
                    console.log(postdata);
                    var lines           = postdata['rows'];
                    var page            = postdata['page'];
                    var sidx            = postdata['sidx'];
                    var sord            = postdata['sord'];
    
                    var offset          = (page-1)*lines;

                    
                    var collection = db.table("records").toCollection();
                    
                    if( postdata['_search'] == true ){
   
                        var filters = JSON.parse(postdata['filters']);
                        var group_op = filters['groupOp'];
                        var rules = filters['rules'];
                       
                        
                        $.each( rules, function( index, rule ) {
                            if(rule.field == 'ts') {
                                var t = new Date();
                                var z = t.getTimezoneOffset() * 60 * 1000;
                                rule.data = Date.parse( rule.data );
                                rule.data -= z;
                            }        
                        });
                        
                        
                        if( group_op == 'AND' ){
                            
                            collection = collection.filter( function(db_record){
    
                                var match = 0;
                                $.each( rules, function( index, rule ) {
                                    if( rule.op == 'eq' &&  db_record[rule.field] == rule.data )    { match++; return; }
                                    if( rule.op == 'ne' &&  db_record[rule.field] != rule.data)     { match++; return; }
                                    if( rule.op == 'lt' &&  db_record[rule.field] <  rule.data)     { match++; return; }
                                    if( rule.op == 'le' &&  db_record[rule.field] <= rule.data )    { match++; return; }
                                    if( rule.op == 'gt' &&  db_record[rule.field] >  rule.data )    { match++; return; }
                                    if( rule.op == 'ge' &&  db_record[rule.field] >= rule.data )    { match++; return; }
                                    if( rule.op == 'nu' &&  db_record[rule.field] == null)          { match++; return; }
                                    if( rule.op == 'nn' &&  db_record[rule.field] != null)          { match++; return; }
                                });
    
                                return ( match == rules.length ); // all rules matched (AND)
                            });
                        
                        }else if( group_op == 'OR' ){
                            collection = collection.filter( function(db_record){
                                for (i = 0; i < rules.length; i++) {
                                    var rule = rules[i];
                                    if( rule.op == 'eq' &&  db_record[rule.field] == rule.data )    return true;
                                    if( rule.op == 'ne' &&  db_record[rule.field] != rule.data)     return true;
                                    if( rule.op == 'lt' &&  db_record[rule.field] <  rule.data)     return true;
                                    if( rule.op == 'le' &&  db_record[rule.field] <= rule.data )    return true;
                                    if( rule.op == 'gt' &&  db_record[rule.field] >  rule.data )    return true;
                                    if( rule.op == 'ge' &&  db_record[rule.field] >= rule.data )    return true;
                                    if( rule.op == 'nu' &&  db_record[rule.field] == null)          return true;
                                    if( rule.op == 'nn' &&  db_record[rule.field] != null)          return true;
                                }   
                                return false;
                            });
                            
                        }
                    }
                    
                    
                    var arr = [];

                    
                    if( sord != undefined && sord != '' && sidx != undefined && sidx != ''){
                    
                        if(sord == 'asc'){
                            arr = await collection.sortBy(sidx).catch(err=>{ console.error(err); });
                        }else{
                            arr = await collection.reverse().sortBy(sidx).catch(err=>{ console.error(err); });
                        }
                    }else{
                        arr = await collection.toArray().catch(err=>{ console.error(err); });
                    }
                    
                    
                    
                    var _records = arr.length;
                    var _total = Math.ceil( _records / lines );
                    var _page = page;
                    
                    arr = arr.slice(offset, offset+lines);
                    $.each( arr, function( index, record ) {
                        record.ts= getLocalDateTimeMsec(record.ts);
                    });
                    
                    arr.records = _records;
                    arr.total = _total;
                    arr.page = _page;

                    $("#datatable")[0].addJSONData(arr);
                    
                    $("#datatable").jqGrid("setCaption", "<span>Data records &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>" + filtered + "&nbsp;&nbsp;&nbsp;<span>[ready]</span>");
                    console.log("processing time: " + (new Date() - jk));                    
                    arr = null;
                })();
                
         

            },
            width:            850,
            shrinkToFit:      true,
            colNames:['recid', 'Timestamp', 'DevId', 'Voltage', 'Current', 'Power', 'Energy', 'Freq', 'cos &#966;'], 
            colModel:[ 
                {name:'id',             index:'id',             width:80,  sortable:true,  editable:false,    title:false, searchoptions:{sopt: num_options}},
                {name:'ts',             index:'ts',             width:160,  sortable:true,  editable:false,    title:false, searchoptions:{sopt: num_options, dataInit: dateTimePick} },
                {name:'devid',          index:'devid',          width:150,  sortable:true,  editable:false,    title:false, searchoptions:{sopt: num_options}, formatter: deviceIdNameFormatter},
                {name:'v',              index:'v',              width:70,  sortable:true,  editable:false,    title:false, searchoptions:{sopt: num_options}},
                {name:'i',              index:'i',              width:70,  sortable:true,  editable:false,    title:false, searchoptions:{sopt: num_options}},
                {name:'p',              index:'p',              width:70,  sortable:true,  editable:false,    title:false, searchoptions:{sopt: num_options}},
                {name:'e',              index:'e',              width:70,  sortable:true,  editable:false,    title:false, searchoptions:{sopt: num_options}},
                {name:'f',              index:'f',              width:60,  sortable:true,  editable:false,    title:false, searchoptions:{sopt: num_options}},
                {name:'pf',             index:'pf',             width:60,  sortable:true,  editable:false,    title:false, searchoptions:{sopt: num_options}}
            ], 
            rowNum:             20, 
            rowList:            [20, 50, 100, 200], 
            viewrecords:        true, 
            height:         'auto', 
            caption:        "Data records",
            sortname:       'id', 
            sortorder:      "desc",
            gridview:       true,
            pager:          "#datapager"
        });    
        
        
        
        
        $("#datatable").jqGrid('navGrid','#datapager', 
            {
                add:        false,
                edit:       false,
                del:        false,
                search:     true,
                refresh:    false  
            },
            {},
            {},
            {},
            {
                closeOnEscape:      true, 
                multipleSearch:     true, 
                closeAfterSearch:   true,
                recreateFilter:     false
            }
        );
        
        
        
        $("#datatable").jqGrid('navGrid',"#datapager").jqGrid('navButtonAdd',"#datapager",{
            caption:"", 
            buttonicon:"ui-icon-refresh", 
            position: "last", 
            title:"Reload Grig", 
            cursor: "pointer",
            onClickButton: function(){
                $("#datatable").trigger("reloadGrid");
            }
        });
        
        
        
        
        
        
        function deviceIdNameFormatter( cellvalue, options, rowObject ){
            var devId = parseInt(cellvalue);
            if( !Number.isInteger( devId ) ){
                return cellvalue;
            }
            else{
                var device = PZEMdevices[devId];
               
                if( device == undefined ){
                    return('[' + cellvalue +'] <span style="color:#F00">Not found!</span>'); 
                }else{
                    return("[" + devId + "] " + device['device']['pzem_name']);
                }
            }
            
        }
        
    };