//=============================
 
    function init_ports_dialogues(){
        
        $( "#addport_dialog" ).dialog({
            autoOpen:   false,
            width:      400,
            height:     500,
            close: function(){
                $("#addport_name").val('');
                $("#addport_descr").val('');
                $("#addport_types").val("RS232").change();
                $("#addport_baudrate").val('9600');
                $("#addport_databits").val("8").change();
                $("#addport_flowcontrol").val("none").change();
                $("#addport_parity").val("none").change();
                $("#addport_stopbits").val("1").change();
            },
            open: function(){
                $("#addport_name").val('');
                $("#addport_descr").val('');
                $("#addport_types").val("RS232").change();
                $("#addport_baudrate").val('9600');
                $("#addport_databits").val("8").change();
                $("#addport_flowcontrol").val("none").change();
                $("#addport_parity").val("none").change();
                $("#addport_stopbits").val("1").change();
                $("#addport_resp_msg").html("");
                
                var selrow = $("#addport_dialog").data('selrow');
                var mode = $("#addport_dialog").data('mode');
                
                if ( mode == "edit" ){
                
                    db.portlist.get(selrow)
                        .then( db_record => {
                            $("#addport_name").val( db_record.port_name );
                            $("#addport_descr").val( db_record.port_descr );
                            $("#addport_types").val( db_record.port_type).change();
                            $("#addport_baudrate").val( db_record.port_baudrate );
                            $("#addport_databits").val( db_record.port_databits ).change();
                            $("#addport_flowcontrol").val( db_record.port_flowcontrol ).change();
                            $("#addport_parity").val( db_record.port_parity ).change();
                            $("#addport_stopbits").val( db_record.port_stopbits ).change();
                        },err => {
                            $("#addport_resp_msg").html("<div style='color:#a93226'>Error while editing port: " + err + " </div>");
                        });
                
                    $('#addport_addbutton_id').button('option', 'label', 'Save');
                }else{
                    $('#addport_addbutton_id').button('option', 'label', 'Add');;
                }
                
            },
            buttons: [
                {
                    id:     'addport_addbutton_id',
                    text:   "",
                    click: function() {
                        $("#addport_resp_msg").html("");

                        var selrow      = $("#addport_dialog").data('selrow');
                        var mode        = $("#addport_dialog").data('mode');
                        
                        var db_record   = {
                            port_name:          $("#addport_name").val(), 
                            port_descr:         $("#addport_descr").val(), 
                            port_type:          $("#addport_types").val(), 
                            port_baudrate:      $("#addport_baudrate").val(), 
                            port_databits:      $("#addport_databits").val(), 
                            port_flowcontrol:   $("#addport_flowcontrol").val(), 
                            port_parity:        $("#addport_parity").val(), 
                            port_stopbits:      $("#addport_stopbits").val()
                            
                        };
                        
                        if ( mode == "edit" ){
                            db_record.id = selrow
                        }
                  
                        db.portlist.put(db_record)
                            .then( id => {
                                $("#addport_resp_msg").html("<div style='color:#117a65'>Successfully " + ((mode=="edit")?"edited":"added") + " port ID " + id + "</div>");
                                $("#portstable").trigger("reloadGrid");
                            },err => {
                                 $("#addport_resp_msg").html("<div style='color:#a93226'>Error while " + ((mode=="edit")?"editing":"adding") +  "a new port: " + err + " </div>");
                            });
                    }
                 },
                {
                    text: "Close",
                    click: function() {
                        $("#addport_resp_msg").html(""),
                        $( this ).dialog( "close" );
                    }
                }
                
            ]
        });
        
        
        $( "#delport_dialog" ).dialog({
            autoOpen:   false,
            width:      400,
            height:     200,
            close: function(){
                $("#delport_consent_msg").val('');
                $("#delport_resp_msg").val('');
            },
            open: function(){
                $("#delport_resp_msg").val('');
                $("#delport_consent_msg").html("Do you really want to <span style='color:red;'> delete </span>port <span style='color:red'>Id " + $("#delport_dialog").data('selrow') + "</span> from database?");
            },
            buttons: [
                {
                    text: "Delete",
                    click: function() {
                        var portid = $("#delport_dialog").data('selrow');
                        
                        db.portlist.delete(portid)
                            .then( id => {
                                $("#delport_consent_msg").html("");
                                $("#portstable").trigger("reloadGrid");
                                $( this ).dialog( "close" );
                            },err => {
                                 $("#delport_resp_msg").html("<div style='color:#a93226'>Error while deleting port: " + err + " </div>");
                            });
                     }
                },
                {
                    text: "Cancel",
                    click: function() {
                        $("#delport_consent_msg").html("");
                        $( this ).dialog( "close" );
                    }
                }                
            ]
 
        });
    }