//=============================

    function init_ports_table(){
    
        $("#portstable").jqGrid({ 
            datatype: function(postdata) {

                db.table("portlist").toArray()
                    .then( dbports => { 
                        
                        // remove from local object ports which does not exist in database
                        Object.keys(serialPorts).forEach( portid => {
                            if ( dbports.find((obj) => { return obj["id"] == portid }) === undefined ){
                                
                                
                                var devid = Object.keys(PZEMdevices).find(devid => PZEMdevices[key]['device']['pzem_port'] == portid);
                                
                                if( serialPorts[portid]['isOpened'] ){
                                    show_err( "Port is absent is DB, but present in local copy and marked as opened Id " + portid );
                                    return;
                                }
                                
                                if( devid != undefined ){
                                    show_err( "Port is absent is DB, but present in local copy and tied to the device Id " + devid );
                                    return; 
                                }

                                delete serialPorts[portid];
                            }
                        });
                        
                        // update port properties from database
                        $.each( dbports, function( index, portobj ) {
                            var old_port = serialPorts[portobj.id];
                            portobj.port_connected = 0;
                            
                            //if( serialPortBuffer[portobj.id] === undefined ){
                            //    serialPortBuffer[portobj.id] = [];
                            //}
                            
                            if( old_port === undefined ){ // create a new object
                            
                                serialPorts[portobj.id] = {
                                                            serialObj:      null, 
                                                            isOpened:       false, 
                                                            portid:         portobj.id, 
                                                            type:           portobj.port_type,
                                                            name:           portobj.port_name,
                                                            isBusy:         false, 
                                                            baudrate:       portobj.port_baudrate, 
                                                            databits:       portobj.port_databits, 
                                                            flowcontrol:    portobj.port_flowcontrol, 
                                                            parity:         portobj.port_parity, 
                                                            stopbits:       portobj.port_stopbits,
                                                            reader:         null,
                                                            writer:         null,
                                                            writeQueue:     [],
                                                            readBuffer:     []
                                                        };
                            }else{ // update database values in the existing object
                                
                                serialPorts[portobj.id]['type']         = portobj.port_type;
                                serialPorts[portobj.id]['name']         = portobj.port_name;
                                serialPorts[portobj.id]['baudrate']     = portobj.port_baudrate
                                serialPorts[portobj.id]['databits']     = portobj.port_databits
                                serialPorts[portobj.id]['flowcontrol']  = portobj.port_flowcontrol
                                serialPorts[portobj.id]['parity']       = portobj.port_parity
                                serialPorts[portobj.id]['stopbits']     = portobj.port_stopbits

                                if(old_port.isOpened) portobj.port_connected = 1;
                            }
                            
                        });
                        
                        $("#portstable")[0].addJSONData(dbports);
                        console.log(serialPorts);

                    }, err => {
                        show_err( "Error while reading ports from DB: " + err )
                        
                    });


            },
            width:            600,
            shrinkToFit:      true,
            colNames:['Id', 'Name', 'Description', 'Type','','Stats'], 
            colModel:[ 
                {name:'id',             index:'id',             width:30,   sortable:false,  editable:false,    title:false, formatter: portIdFormatter},
                {name:'port_name',      index:'port_name',      width:100,  sortable:false,  editable:false,    title:false},
                {name:'port_descr',     index:'port_descr',     width:200,  sortable:false,  editable:false,    title:false},
                {name:'port_type',      index:'port_type',      width:60,   sortable:false,  editable:false,    title:false},
                {name:'port_connected', index:'port_connected', width:0,    sortable:false,  editable:false,    title:false, hidden:true },
                {name:'port_stats',      index:'port_stats',      width:100,   sortable:false,  editable:false,    title:false}
            ], 
            pginput:        false,
            pgbuttons:      false,
            viewrecords:    false, 
            rows:           100,
            height:         'auto', 
            caption:        "Available serial ports",
            sortname:       'id', 
            sortorder:      "desc",
            gridview:       true,
            rowattr: function (rd) {
                 if (rd.port_connected == 1) { 
                    return {"class": "JqRowGreen"};
                }
            },
            pager:          "#portspager",
            editurl:        'clientArray',
            loadError : function(xhr,st,err) {
                show_err( "Error while loading data to the table" );
            },
        });
        
        
        $("#portstable").jqGrid('navGrid','#portspager', 
            {
                add:        false,
                edit:       false,
                del:        false,
                search:     false,
                refresh:    true  
            },
            {},
            {},
            {},
            {}
        );
        
///////////////////////////////////////    
    
        $("#portstable").jqGrid('navGrid',"#portspager").jqGrid('navButtonAdd',"#portspager",{
            caption:"", 
            buttonicon:"ui-icon-trash", 
            position: "first", 
            title:"Delete port", 
            cursor: "pointer",
            onClickButton: function(){
            
                var selrow = parseInt( $("#portstable").jqGrid ('getGridParam', 'selrow') );
                if( !Number.isInteger( selrow ) ){
                    show_err( 'error: No row selected');
                }
                else{
                    // check if current port is in pollingQueue
                    //var dev_id = Object.keys(pollingQueue).filter(function(key) {return pollingQueue[key]['device']['pzem_port'] == selrow})[0];
                    var dev_id = Object.keys(PZEMdevices).filter(function(devid) {return ((PZEMdevices[devid]['device']['pzem_port'] == selrow) && (PZEMdevices[devid]['active'] == true)) })[0];
                               
                    if( !Number.isInteger( parseInt( dev_id ) ) ){
                        $("#delport_dialog").data('selrow', selrow).dialog('open');
                    }else{
                        show_err( 'Port Id ' + selrow + ' is currently used for device Id ' + dev_id);
                        return
                    }
                }
            }
        });
        
 //////////////////////////////////
 
        $("#portstable").jqGrid('navGrid',"#portspager").jqGrid('navButtonAdd',"#portspager",{
            caption:"", 
            buttonicon:"ui-icon-link", 
            position: "first", 
            title:"Open/Close port", 
            cursor: "pointer",
            onClickButton: function(){
            
                var selrow = parseInt( $("#portstable").jqGrid ('getGridParam', 'selrow') );
                if( !Number.isInteger( selrow ) ){
                    show_err( 'error: No row selected');
                    return;
                }
                    
                var cur_port = serialPorts[selrow]; 
                if( cur_port === undefined ){
                    show_err( 'error while saving port state: port not found');
                    return;
                }
                
                if( cur_port.isOpened ){ // then closing port
                    
                    var devid = Object.keys(PZEMdevices).find(key => (PZEMdevices[key]['device']['pzem_port'] == selrow) && (PZEMdevices[key]['active'] == true) );
                    if( devid != undefined ){
                        show_err( 'This port is currently in use for device Id: ' + devid);
                        return;
                    }
                
                    (async function() {
                       cur_port.keepReading = false; 

                       await cur_port.reader.cancel();
                       await cur_port.serialObj.close().catch(err => {show_err( 'error while closing port: ' + err); return;})
                       
                       cur_port.isOpened = false;
                       cur_port.reader = null;
                       cur_port.writer = null;
                       cur_port.serialObj = null;
                       $("#portstable").trigger("reloadGrid");
                    })();
                    

                }else{ // then open port
                    (async function() {

                        
                        if( cur_port === undefined ){
                            show_err( 'error while saving port state: port not found');
                            return;
                        }else{
                            try {
                                const port = await navigator.serial.requestPort();
                                cur_port.serialObj = port;
                                
                                if(cur_port.type == "RS232" || cur_port.type == "RS485" ){
                                    
                                    await port.open({ 
                                                        baudRate:       cur_port.baudrate, 
                                                        dataBits:       cur_port.databits, 
                                                        flowControl:    cur_port.flowcontrol, 
                                                        parity:         cur_port.parity, 
                                                        stopBits:       cur_port.stopbits
                                                    })
                                        .then( ok =>{
                                            cur_port.isOpened = true;
                                        },err => {
                                           console.error("unable to open port " + err);
                                           return;
                                        });
                                }else{
                                    throw new Error('unable to open unknown port type ' + cur_port.type);
                                }
                                
                                
                                
                                //console.log(port.readable);
                                cur_port.keepReading = true;
                                cur_port.reader = null;
                                cur_port.writer = null;
                                listen_serial_port( cur_port.portid )
                                //console.log(cur_port);

                                
                                cur_port.serialObj.addEventListener('disconnect', (event) => {
                                    var p = serialPorts[selrow] 
                                    console.log("port disconnected! Id: " + selrow);
                                    
                                    $.each( Object.keys(PZEMdevices), function( index, devid ) {
                                        if( PZEMdevices[devid]['device']['pzem_port'] == p.portid ){
                                            //delete pollingQueue[ key ];
                                            PZEMdevices[devid]['active'] = false;
                                            console.log("disactivating associated device : id " + devid);
                                        }
                                    });
                                    
                                    p.isOpened = false;
                                    p.reader = null;
                                    p.writer = null;
                                    p.serialObj = null;
                                    p.writeQueue.length = 0;
                                    p.readBuffer.length = 0;
                                    if( curPage == 1 ) $("#pzemtable").trigger("reloadGrid");
                                });
                            }catch(err) {
                                show_err('There was an error opening the serial port:', err);
                            }
                            $("#portstable").trigger("reloadGrid");
                        }
                    
                    })();
                }
            }
        });

/////////////////////////////////
        
        $("#portstable").jqGrid('navGrid',"#portspager").jqGrid('navButtonAdd',"#portspager",{
            caption:"", 
            buttonicon:"ui-icon-pencil", 
            position: "first", 
            title:"Edit port", 
            cursor: "pointer",
            onClickButton: function(){
                var selrow = parseInt( $("#portstable").jqGrid ('getGridParam', 'selrow') );
                if( !Number.isInteger( selrow ) ){
                    show_err( 'error: No row selected' );
                }
                else{
                    $( "#addport_dialog" ).dialog({ title: "Edit port Id " + selrow });
                    $("#addport_dialog").data( {'selrow' : selrow, 'mode' : 'edit'} ).dialog('open');
                }
            }
        });
        
        $("#portstable").jqGrid('navGrid',"#portspager").jqGrid('navButtonAdd',"#portspager",{
            caption:"", 
            buttonicon:"ui-icon-plus", 
            position: "first", 
            title:"Add new port", 
            cursor: "pointer",
            onClickButton: function(){
                $( "#addport_dialog" ).dialog({ title: "Add a new port"});
                $("#addport_dialog").data({'mode': 'add'}).dialog('open');
                
            }
        });
        
        
        function portIdFormatter ( cellvalue, options, rowObject ){
            
            var portId = parseInt(cellvalue);
            if( !Number.isInteger( portId ) ){
                return cellvalue;
            }
            else{
                
                if(rowObject.port_connected == 1){
                    return('<span class="ui-icon ui-icon-link"></span>' + cellvalue);
                }else{
                    
                    return(  cellvalue);
                }
            }
        }
        
    }