function init_chart(){
    
    $("#chart_datebeg, #chart_dateend").datetimepicker({ 
        dateFormat: 'yy-mm-dd', 
        timeFormat: 'HH:mm:ss',
        showHour: true,
        showMinute: true,
        showSecond: true,
        showMillisec: false,
        showMicrosec: false,
        showTimezone: false
    });
    
   // make_resizable_chart();
    
    
     
    $("#chart_draw").click(async function(){
        var datebeg = $("#chart_datebeg").val();
        var dateend = $("#chart_dateend").val();
        var devid = parseInt( $("#chart_devid").val());
        var param = $("#chart_param").val();
        chart_data.length = 0;
        
        var t = new Date();
        var z = t.getTimezoneOffset() * 60 * 1000;
        datebeg = Date.parse( datebeg );
        datebeg -= z;
        
        dateend = Date.parse( dateend );
        dateend -= z;
         
        var dbdata = await db.table('records').where('ts')
            .between(datebeg, dateend, true, true)
            .filter(function (record) {
                return record.devid == devid;
            }).sortBy('ts');
  
        $.each( dbdata, function( index, record ) {
                chart_data.push([record.ts, record[param]]);
        });  
        
     
       
        drawApexChart(chart_data, $( "#chart_param option:selected" ).text());
         
    });
     



    function drawApexChart(data, param){
        
        var options = {
            series: [{
                name: param,
                data: data
            }],
            chart: {
                type: 'line',
                width: '100%',
                height: $("#apexchart_container_div").height() - 15,
                parentHeightOffset: 0,
                redrawOnParentResize: false,
                zoom: {
                    type: 'xy', 
                    enabled: true,
                    autoScaleYaxis: true,
                },
                toolbar: {
                        autoSelected: 'zoom'
                }
            },
            stroke: {
                curve: 'straight',
                width: 1.5
            },
            dataLabels: {
                enabled: false
            },
            markers: {
            size: 0,
            },
            title: {
            text: '',
            },
            yaxis: {
                forceNiceScale: true,
                labels: {
                },
                title: {
                    text:  param
                },
            },
            xaxis: {
                type: 'datetime',
                labels: {
                }
            },
            tooltip: {
                shared: false,
                x: {
                    formatter: function(value){
                        return getLocalDateTimeMsec(value);
                    }
                }
    //            x: { // doesn't show milliseconds
    //                format: 'yy-MM-dd HH:mm:ss.fff',
    //            }
            }
        };
            
        if( chart1 != null && chart1 != undefined ) destroyChart(); 
        
        chart1 = new ApexCharts(document.querySelector("#apexchart_container_div"), options);
        chart1.render().then(ok => {
                    $("#apexchart_container_div").css("min-height", "10px");
                },err => {
                    console.log("Chart rendering failed " + err);
                });
        
    }    

    
}

function update_chart_devids(){
    var selopt = $("#chart_devid").val();
   
    $("#chart_devid").empty();
    db.devlist.toArray()
        .then( devices => {

            $.each( devices, function( index, device ) {
                $("#chart_devid").append('<option value="' + device.id + '">['+ device.id+'] ' + device.pzem_name + '</option>');
            });
            
            if( selopt != null && selopt != undefined){
                $("#chart_devid").val(selopt).change();
            }    
        },err => {
            show_err( "Error while reading devices from DB: " + err );
        });
    
    
    

}

/*
function make_resizable_chart(){
    
       $( "#apexchart_container_div" ).resizable({
        stop: function( event, ui ) {

                if(chart1 != null && chart1 != undefined ) chart1.updateOptions({
                    chart: {
                        width: $("#apexchart_container_div").width() - 15,
                        height: $("#apexchart_container_div").height() - 15
                    }
                }).then( ok =>{
                    $("#apexchart_container_div").css("min-height", "10px");
                    $( "#apexchart_container_div" ).resizable( "destroy" );
                    make_resizable_chart();
                });
        }
            
    });
    
}

*/